#define  BufSize  16            /* Buffer Size */
#define  AV  0x0		/* positionnement du relais en position avant   */
#define  AR  0x40		/* positionnement du relais en position arriere */
#define SIGNAL_INIT 20970		/* Defini le temps (de 0 a 32767) ou le signal du pwm est a 0
				    Le temps ou le signal est a 1 defini la distance maximum
				    ou l on peut reperer un obstacle par les ultrasons */ 

int discap1=0, discap2=0, discap3=0, discap4=0, discap5=0, discap6=0, discap7=0;
int disold1=0, disold2=0, disold3=0, disold4=0, disold5=0, disold6=0, disold7=0;
int valold=0;
int boucle=0;
char mask[8]; /*Sert a masquer les capteur non branche pour eviter un affichage superflu*/

/********************************* UAR PUT **************************************/
int UARTPutString(int UartNb, char *St)
{
	int Result = 0;
	while ((St[0] != 0) && (Result == 0)) {
		Result = UARTPutChar(UartNb, St[0]);
		St++;
  	}
  	return (Result);
}
 

/******************** Prog d'ecriture des valeurs sur l'UAR *********************/
void tostring(int v,char buffer[11])
{
	static char num[11]="0123456789";
	char sign;
	int k = 0;
	unsigned int uv;

	for (k=0;k<10;k++) buffer[k] = ' ';
	buffer[k] = 0;
	k-=1;

	sign = (v<0)?'-':' ';
	uv = (sign=='-')?((unsigned int)-v):((unsigned int)v);
	while (1)
	{
		buffer[k--] = num[uv%10];
		uv = uv / 10;
		if (uv == 0) break;
	} 
	buffer[k--] = sign;
}


/******************** Prog d'ecriture de chaine sur le LCD *********************/
static int LCDPutString(char *St)
{
  int Result = 0;
  while ((St[0] != 0) && (Result == 0)) {
    Result = LCDPutChar( St[0]);
    St++;
  }
  return (Result);
}

/******************** Prog permettant d attendre *********************/
static void mpc555Delay(int temps)
{
  volatile int i;

  for (i=0;i<temps*100;i++);
}

/******************************* Interrupt **************************************/
void InterruptHandlerCAN0(void)
{
  	UARTPutString( 0, "\n\r CAN0");
}

void InterruptHandlerCAN1(void)
{
  	UARTPutString( 0, "\n\r CAN1");
} 

void InterruptHandlerSPI(void)
{
  	UARTPutString( 0, "\n\r SPI");
}  

void InterruptHandler2(void)
{
/* Interruption du TPU */
	char st[50];
	int val=0;;
	UltraDisInt();

	ReadEtatCap(&val);

	Ultra0Read( &discap1);	/* Lit les valeurs des canaux TPU */
	Ultra1Read( &discap2);
  	Ultra2Read( &discap3);
	Ultra3Read( &discap4);
	Ultra5Read( &discap5);
	Ultra6Read( &discap6);
	Ultra7Read( &discap7);

	if( discap1 != disold1 && mask[1]!=0  && discap1 < 5000){
		UARTPutString( 0, "\n\r Distance capteur 1 : ");
  		tostring( discap1, st); 
  		UARTPutString( 0, st);
		disold1 = discap1;
	}

	if( discap2 != disold2 && mask[2]!=0 && discap2 < 5000){
		UARTPutString( 0, "\n\r Distance capteur 2 : ");
  		tostring( discap2, st); 
  		UARTPutString( 0, st);
		disold2 = discap2;
	}

	if( discap3 != disold3 && mask[3]!=0 && discap3 < 5000){
		UARTPutString( 0, "\n\r Distance capteur 3 : ");
  		tostring( discap3, st); 
  		UARTPutString( 0, st);
		disold3 = discap3;
	}

	if( discap4 != disold4 && mask[4]!=0 && discap4 < 5000){
		UARTPutString( 0, "\n\r Distance capteur 4 : ");
  		tostring( discap4, st); 
  		UARTPutString( 0, st);
		disold4 = discap4;
	}

	if( discap5 != disold5 && mask[5]!=0 && discap5 < 5000){
		UARTPutString( 0, "\n\r Distance capteur 5 : ");
  		tostring( discap5, st); 
  		UARTPutString( 0, st);
		disold5 = discap5;
	}

	if( discap6 != disold6 && mask[6]!=0 && discap6 < 5000){
		UARTPutString( 0, "\n\r Distance capteur 6 : ");
  		tostring( discap6, st); 
  		UARTPutString( 0, st);
		disold6 = discap6;
	}

	if( discap7 != disold7 && mask[7]!=0 && discap7 < 5000 ){
		UARTPutString( 0, "\n\r Distance capteur 7 : ");
  		tostring( discap7, st); 
  		UARTPutString( 0, st);
		disold7 = discap7;
	}

 
  	TPUInitUltra();
} 

void InterruptHandler6(void)
{
  	
	UARTPutString(0,"\n\r IHandler6");
}

void InterruptHandler7(void)
{
/*Interruption du PWM*/
int etat;
PWMDisInt();		/* Disable Interruption */
PWMRead(&etat);		/* Lit l etat du PWM */
if (etat>=1) {
	TPU3Inittcr1();	/* Initialisation des canaux TPU ===> Le compteur demarre */
	TPUInitUltra();
	}
else {
	TPUStop();	/*Arret des canaux TPU et re;ise a zero des compteurs*/
	TPUReset();
	}
PWMEnInt();		/* Enable Interruption */
}

void InterruptHandlerPIT(void)
{
  	SetLED(!(SetLED(0)));
}


/*---------------------------------------------------------------------------*/
/* Interrupt handler reserved for EXTERNAL IRQ lines                         */
/*---------------------------------------------------------------------------*/
void InterruptHandlerIRQ0(void)
{
  	UARTPutString(0,"\n\r IRQ0");
}

void InterruptHandlerIRQ1(void)
{
  	UARTPutString(0,"\n\r IRQ1");
}

void InterruptHandlerIRQ2(void)
{
  	UARTPutString(0,"\n\r IRQ2");
}

void InterruptHandlerIRQ3(void)
{
  	UARTPutString(0,"\n\r IRQ3");
}

void InterruptHandlerIRQ4(void)
{
  	UARTPutString(0,"\n\r IRQ4");
}

void InterruptHandlerIRQ5(void)
{
  	UARTPutString(0,"\n\r IRQ5");
}

void InterruptHandlerIRQ6(void)
{
  	UARTPutString(0,"\n\r IRQ6");
}

void InterruptHandlerIRQ7(void)
{
  	UARTPutString(0,"\n\r IRQ7");
} 


/********************************* PWM ACTIVATION *******************************************/

void PWMActiveAR(int choix) {
/* Active les capteurs arriere, il n est pas possible d activer a la fois les capteurs arriere et
	 avant */
short int alpha = SIGNAL_INIT;

/*  choix possibles : 1 pour activer le capteur 1, choix 2 pour les capteurs 2 3 et 4 et choix 3
	pour activer les capteurs 5,6 et 7
    On peut activer plusieurs groupes de capteurs a la fois */


MPIOPWMAR();	/* enclenchement du relais (position arriere)    */
			
PWMWrite(1, &alpha);	/* Signal PWM a 1 pendant 20ms et a 0 pendant 40ms */


switch(choix) {
	case 1 : mask[1]=1;
		 MPIOEn1();	/* Gere l I/0 pour que le pwm arrive jusqu au capteur du groupe 1*/
		 break;
	case 2 : mask[2]=1;
		 mask[3]=1;
		 mask[4]=1;
		 MPIOEn2();	/* Gere l I/0 pour que le pwm arrive jusqu au capteur du groupe 2*/
		 break;
	case 3 : mask[5]=1;
		 mask[6]=1;
		 mask[7]=1;
		 MPIOEn3();	/* Gere l I/0 pour que le pwm arrive jusqu au capteur du groupe 3*/
		 break;
	}


}

void PWMActiveAV(int choix) {
/* Active les capteurs avant, il n est pas possible d activer a la fois les capteurs arriere et
	 avant */
short int alpha = SIGNAL_INIT;
/*  choix possibles : 1 pour activer le capteur 1,2 et 5, choix 2 pour les capteurs 3 et 6 et choix 3
	pour activer les capteurs 4 et 7
    On peut activer plusieurs groupes de capteurs a la fois */
PWMWrite(1, &alpha);	/* Signal PWM a 1 pendant 20ms et a 0 pendant 40ms */
MPIOPWMAV();	/* enclenchement du relais (position avant)    */
switch(choix) {
	case 1 : mask[1]=1;
		 mask[2]=1;
		 mask[5]=1;
		 MPIOEn1();	/* Gere l I/0 pour que le pwm arrive jusqu au capteur du groupe 1*/
		 break;
	case 2 : mask[3]=1;
		 mask[6]=1;
		 MPIOEn2();	/* Gere l I/0 pour que le pwm arrive jusqu au capteur du groupe 2*/
		 break;
	case 3 : mask[4]=1;
		 mask[7]=1;
		 MPIOEn3();	/* Gere l I/0 pour que le pwm arrive jusqu au capteur du groupe 3*/
		 break;
	}
}
 
/************************************* MAIN **************************************/
int main(){
  	int i;
  	char Buffer[BufSize];	/* For RX */
  	char st[50];
    	short int alpha = SIGNAL_INIT;
	
	for (i=0;i<8;i++) {
		mask[i]=0;
	  }
  	UARTInit(0, 9600, 8, 1, 0, &Buffer, BufSize);
  	InitInterrupt(0);		/* initialisation de des interruption voir fichier intasm.s       */
  	UARTPutString(0, "\n\r Debut du programme \n\r");
	MPIOInit();		/* Initialisation des entrees sorties */
	PWMInit();		/* initialisation des parametre pour PWM voir fichier pwmasm.s */
	PWMActiveAR(2);		/* Initialisation de la gestion des capteurs par rapport au PWM */
	PWMEnInt();		/* Enable Interruption PWM */
	return 0;
}
