#*****************************************************************************
#* File:  CRT0.S
#* Version: 1.00,   01/10/1999
#* Author:  Philippe TECHER,  Virtual Micro Degin (ptecher@vmdesign.com)
#* Modified by: M. GHRISSI 04/11/99 
#-----------------------------------------------------------------------------
#* Modification:
#*   1.00 - Base version
#-----------------------------------------------------------------------------

#******************************************************************************

        .file           "crt0.s"
        .text
        .globl          start
        .align          2

	.include 	"555regsdef.s"

#******************************************************************************
.macro 	Set32	AdRgHi,AdRgLo,ValHi,ValLo
		addis	r11,r0,\AdRgHi
		ori	r11,11,\AdRgLo
		addis	r12,r0,\ValHi
		ori	r12,r12,\ValLo
		stw	r12,0(r11)
	.endm

.macro 	Set16	AdRgHi,AdRgLo,Value
		addis	r11,r0,\AdRgHi
		ori	r11,r11,\AdRgLo
		li	r12,\Value
		sth	r12,0(r11)
	.endm
	
#******************************************************************************
#******************************************************************************

        addi            r0,r0,0         	# Debuggers may object to starting at 0.

start:
	addis		r11,r0,__SP_INIT@ha		# Initialize stack pointer r1 to
	addi		r1,r11,__SP_INIT@l		# value in linker command file.
	addis		r13,r0,_SDA_BASE_@ha	# Initialize r13 to sdata base
	addi		r13,r13,_SDA_BASE_@l	# (provided by linker).
	addis		r2,r0,_SDA2_BASE_@ha	# Initialize r2 to sdata2 base
	addi		r2,r2,_SDA2_BASE_@l		# (provided by linker).
	addi		r0,r0,0					# Clear r0.
	stwu		r0,-64(r1)				# Terminate stack.

#******************************************************************************
# Insert other initialize code here.
	mfmsr	r0
	ori	r0,r0,0x2002
	mtmsr	r0

	li	r0,0x07
	mtspr	158,r0

#	set16	0x002F, 0xC288, -0x0001		# clear reset status

	li	r0,0

#
# Finished user initialisation

# bl              __init_main     			# Finishes initialization (copies .data
                                        	# ROM to RAM, clears .bss), then calls
                                        	# example main(), which calls exit(),
                                        	# which halts.
# b		exit						# Never returns.
	bl		main					# Dummy to pull in main() as soon as
									# possible.
    
#------------------------------------------------------------- .init section --
        .section        .init
        .globl          __init
        .align          2
__init:                                 	# Entry to __init, called by
        mfspr           r0,8            	# __init_main called above.
        stwu            r1,-64(r1)
        stw             r0,68(r1)

        # Linker places .init sections from other modules, containing       
        # calls to initialize global objects, here.                         

        .section        .init
        lwz             r0,68(r1)       	# Return from __init.
        addi            r1,r1,64
        mtspr           8,r0
        blr

#------------------------------------------------------------- .fini section --
        .section        .fini
        .globl          __fini
        .align          2
__fini:                                 # Entry to __fini, called by exit().
        mfspr           r0,8
        stwu            r1,-64(r1)
        stw             r0,68(r1)

        # Linker places .fini sections from other modules, containing       
        # calls to destroy global objects, here.                            

        .section        .fini
        lwz             r0,68(r1)       # Return from __fini.
        addi            r1,r1,64
        mtspr           8,r0
        blr
