#*****************************************************************************
#* File: PWMASM.S 
#* Version: 1.00,   15/10/1999
#* Author:  Meftah GHRISSI,  Robosoft (meftah@robosoft.fr) 
#-----------------------------------------------------------------------------
#* Modification:
#*   1.00 - Base version
#*   1.01 - Sebastien Heraud, Stagiaire INRIA (s.heraud@caramail.com)
#*   1.02 - ...
#-----------------------------------------------------------------------------

       .name           	"pwmasm.s"
       .text
       .include         "555regsdef.s"

	.xdef	PWMInit
	.xdef	PWMWrite
	.xdef	PWMRead
	.xdef	WatchDog
	.xdef	PWMDisInt
	.xdef	PWMEnInt

# ********************************************************
# Syntax
# A_NameHi : Refers MSB 16bit Address  for "name" Module 
# A_NameLo : Refers LSB 16bit Address  for "name" Register 
# V_Name   : Refers     16bit Value to set "name" Register 
	A_USIUHi		=	0x002F     
	A_USIU_MEMCRHi		=	0x002F
	A_TI_FlashHi		=	0x0080  
	A_USIU_THi		=	0x002F     
	A_USIU_CRHi		=	0x002F 
        A_MIOSHi		=	0x0030
	Zero			=	0x0000
# ********************************************************
# SYPCR
	A_SYPCRLo	=	0xC004  		
	V_SYPCRHi	=	0x0000
	V_SYPCRLo	=	0xFF00
# OR0
	A_OR0Lo		=	0xC104  		
	V_OR0Hi		=	0xFFF0
	V_OR0Lo		=	0x0050
# BR0
	A_BR0Lo		=	0xC100  		
	V_BR0Hi		=	0x0080
	V_BR0Lo		=	0x0003
# TI Flash
	A_TI_FlashLo	=	0x0000  		
	V_TI_Flash96	=	0x0096
	V_TI_Flash5B	=	0x005B
	V_TI_FlashFF	=	0x00FF
# OR1
	A_OR1Lo		=	0xC10C 		
	V_OR1Hi		=	0xFFC0
	V_OR1Lo		=	0x0000
# BR1
	A_BR1Lo		=	0xC108  		
	V_BR1Hi		=	0x00C0
	V_BR1Lo		=	0x0003
# OR2
	A_OR2Lo		=	0xC114		
	V_OR2Hi		=	0xFFFF
	V_OR2Lo		=	0x8120
# BR2
	A_BR2Lo		=	0xC110  		
	V_BR2Hi		=	0xFFFF
	V_BR2Lo		=	0x8001

# OR3
	A_OR3Lo		=	0xC11c		
	V_OR3Hi		=	0xFFFF
	V_OR3Lo		=	0x8120
# BR3
	A_BR3Lo		=	0xC118  		
	V_BR3Hi		=	0xFFFF
	V_BR3Lo		=	0x8001




# ********************************************************
# initialization
# UMCR UIMB Module Configuration Register
	A_UMCRLo	=	0x7F80  		
	V_UMCRHi	=	0x0000
	V_UMCRLo	=	0x0000
# TBSCR Time Base Status and Control
	A_TBSCRLo	=	0xC200	
	V_TBSCR		=	0x0001
# PDMCR Pads Module Configuration Register
	A_PDMCRLo	=	0xC03C
	V_PDMCRHi	=	0x1300
	V_PDMCRLo	=	0x0000
# ********************************************************
 # Other Miscellaneous Initialization Registers for Reference
# SPR158 ICTRL I-Bus Support Control Register
	V_SPR158_ICTRL	=	0x0007
# PLPRCR PLL Low Power and Reset Control Register 
	A_PLPRCRLo	=	0xC284
	V_PLPRCRHi	=	0x0091
	V_PLPRCRLo	=	0xc000
# ********************************************************
# Configuring the PWM Channels
# COUNTER PRESCALER MCPSM Status/Control Register"
# Whith a FSYS of 40 MHz...
# PSL set to 2 to multiply by PWMSCR (CP set to 1)
# to generate a 40 MHz / (PSL*CP) = 20 MHz PWM Clock (50 ns step)
	A_MCPSMLo	=	0x6816
	# V_MCPSM	=	0x8002
	V_MCPSM		=	-0x7F09
# CHANNEL 0
# PWM Period Register (Resolution of waveform)
# Whith 20 MHz MPW Clock
# Period Resolution set to 0x3E8=500
# to generate a 20 MHz / 500 = 20 KHz PWM Signal 0,000.05 sec = 50 sec
# MPWMSM0 Period Register
	A_MPWMSM0_PeLo	=	0x6000
	V_MPWMSM0_Pe	=	0x7fff
# PWM Pulse Width Register (How many periods from above that are high)
# Pulse set to 0x3E8 / 2 = 0x1F4 =250 (The half, only for test, O when init)
# MPWMSM0 Pulse Width RegisterMPWMSM0
	A_MPWMSM0_PuLo	=	0x6002
	V_MPWMSM0_Pu	=	0x0000
# PWM Status and control (Divider per PWM)
# MPWMSM0 Status and control
# Whith a FSYS of 40 MHz...
# CP set to 1 to multiply by MCPSM (CPL set to 2)
# to generate a 40 MHz / (PSL*CP) = 20 MHz PWM Clock (50 ns step)
	A_MPWMSM0_SCLo	=	0x6006
	V_MPWMSM0_SC	=	0x54F6
# CHANNEL 1
	A_MPWMSM1_PeLo	=	0x6008
	V_MPWMSM1_Pe	=	0x7fff    #facteur de division de frequence ici
	                              #32767 soit f=61Hz->3m
 
	
	A_MPWMSM1_PuLo	=	0x600A
	V_MPWMSM1_Pu	=	0x0000
	A_MPWMSM1_SCLo	=	0x600E
	V_MPWMSM1_SC	=	0x54F6    #les derniers "digit" 0x54XX represente
                                      #le facteur de division de l'horloge
					          #f-> fact 1 et 6-> fact 10 ...	
# CHANNEL 2                                 
	A_MPWMSM2_PeLo	=	0x6010
	V_MPWMSM2_Pe	=	0x00FA    #
ici f=2KHz
	A_MPWMSM2_PuLo	=	0x6012
	V_MPWMSM2_Pu	=	0x0000
	A_MPWMSM2_SCLo	=	0x6016
	V_MPWMSM2_SC	=	0x54F6
# CHANNEL 3
	A_MPWMSM3_PeLo	=	0x6018
	V_MPWMSM3_Pe	=	0x16FA    #
ici f=344Hz->1m
	A_MPWMSM3_PuLo	=	0x601A
	V_MPWMSM3_Pu	=	0x0000
	A_MPWMSM3_SCLo	=	0x601E
	V_MPWMSM3_SC	=	0x54F6
	
# Interruption
	A_MIOS1ER0 	= 	0x6C04
	A_MIOS1SR0	=	0x6C00
	A_MIOS1LVL0	=	0x6C30
	
# ********************************************************
.macro Set32 AdRgHi,AdRgLo,ValHi,ValLo
		addis	r11,r0,\AdRgHi
		ori	r11,r11,\AdRgLo
		addis	r12,r0,\ValHi
		ori	r12,r12,\ValLo
		stw	r12,0(r11)
	.endm
.macro Set16 AdRgHi,AdRgLo,Value
		addis	r11,r0,\AdRgHi
		ori	r11,r11,\AdRgLo
		li	r12,\Value
		sth	r12,0(r11)
	.endm	


#********************************************************
#PWMInit
#	Initialisation de PWM1 (Seul PWM utilise pour les ultra son)
#********************************************************
PWMInit:	
# Save context r0,r11,r12,LR,CR,SRR0,SRR1
	stwu	r1,-0x30(r1)	# Make a 3 word frame in the stack
	stw	r0,0x10(r1)	# Save r0
	stw	r11,0x14(r1)	# Save r11
	stw	r12,0x18(r1)	# Save r12	
	mfspr	r0,LR		# Get LR Link Register 
	stw	r0,0x1C(r1)	# Save it
	mfcr	r0		# Get CR Condition Register
	stw	r0,0x20(r1)	# Save it
	li	r0,0		# Set r0=0x0

# Configuring PWD All Channels 
	Set16 A_MIOSHi ,A_MCPSMLo,V_MCPSM		#Set COUNTER PRESCALER MCPSM Status/Control Register
# Configuring PWD Channel 0
#	Set16 A_MIOSHi ,A_MPWMSM0_PeLo ,V_MPWMSM0_Pe	#Set CHANNEL 0 PWM Period Register
#	Set16 A_MIOSHi ,A_MPWMSM0_PuLo ,V_MPWMSM0_Pu	#Set CHANNEL 0 PWM Pulse  Register
#	Set16 A_MIOSHi ,A_MPWMSM0_SCLo ,V_MPWMSM0_SC	#Set CHANNEL 0 PWM Status/Control Register
# Configuring PWD Channel 1
	Set16 A_MIOSHi ,A_MPWMSM1_PeLo ,V_MPWMSM1_Pe	#Set CHANNEL 1 PWM Period Register
	Set16 A_MIOSHi ,A_MPWMSM1_PuLo ,V_MPWMSM1_Pu	#Set CHANNEL 1 PWM Pulse  Register
	Set16 A_MIOSHi ,A_MPWMSM1_SCLo ,V_MPWMSM1_SC	#Set CHANNEL 1 PWM Status/Control Register
# Configuring PWD Channel 2
#	Set16 A_MIOSHi ,A_MPWMSM2_PeLo ,V_MPWMSM2_Pe	#Set CHANNEL 2 PWM Period Register
#	Set16 A_MIOSHi ,A_MPWMSM2_PuLo ,V_MPWMSM2_Pu	#Set CHANNEL 2 PWM Pulse  Register
#	Set16 A_MIOSHi ,A_MPWMSM2_SCLo ,V_MPWMSM2_SC	#Set CHANNEL 2 PWM Status/Control Register
# Configuring PWD Channel 3
#	Set16 A_MIOSHi ,A_MPWMSM3_PeLo ,V_MPWMSM3_Pe	#Set CHANNEL 3 PWM Period Register
#	Set16 A_MIOSHi ,A_MPWMSM3_PuLo ,V_MPWMSM3_Pu	#Set CHANNEL 3 PWM Pulse  Register
#	Set16 A_MIOSHi ,A_MPWMSM3_SCLo ,V_MPWMSM3_SC	#Set CHANNEL 3 PWM Status/Control Register

# Configure Interruption
	addis	r11,r0,A_MIOSHi	    	# Disable Interrupt on PWM1
	ori	r11,r11,A_MIOS1ER0
	lhz	r12,0(r11)
	andi.	r12,r12,0xFFFD
	sth	r12,0(r11)
	
	addis	r11,r0,A_MIOSHi   	# Read Interrupt Status Register (MIOS1SR0)
	ori	r11,r11,A_MIOS1SR0
	lhz	r12,0(r11)
	
	sth	r0,0(r11)       	# Clear interrupt status register
	
#	addis	r11,r0,A_MIOSHi  	# Enable interrupt on PWM1
#	ori	r11,r11,A_MIOS1ER0
#	lhz	r12,0(r11)
#	ori	r12,r12,0x2
#	sth	r12,0(r11)
	
	addis	r11,r0,A_MIOSHi  	# Enable servicing by asigning a Priority
	ori	r11,r11,A_MIOS1LVL0
	lhz	r12,0(r11)
	ori	r12,r12,0x700
	sth	r12,0(r11)
	
	
# Restore Context r0,r11,r12,LR,CR,SRR0,SRR1
	lwz	r0,0x20(r1)	# Get CR off stack
	mtcrf	0xFF,r0		# Restore CR Condition Register
	lwz	r0,0x1C(r1)	# Get LR off stack
	mtspr	LR,r0		# Restore LR Link Register 
	lwz	r12,0x18(r1)	# Restore r12
	lwz	r11,0x14(r1)	# Restore r11	
	lwz	r0,0x10(r1)	# Restore r0
	addi	r1,r1,0x30	# Restore Stack	Pointer
	blr			# Branch to Link Register, Return from Subroutine RTS 

#*****************************************
# PWMWrite (int axis, short int *value)
# Write to PWM channel 0 to 3 (4 axis board)
# Channel 0 : axis 1
# r3 = axis, r4= adresse Value
#******************************************
PWMWrite:
	stwu	r1,-0x18(r1)
	mfspr	r0,LR
	stw	r30,0x10(r1)
	stw	r31,0x14(r1)
	stw	r0,0x1C(r1)
	
	li	r31,0
	addis	r30,r31,A_MIOSHi	
	ori	r30,r30,A_MPWMSM0_PuLo	#r30=0x00306002 axe1
	
	mulli	r31,r3,0x8	# r31 = offset axis
	add	r30,r30,r31
	lhz	r0,0x0(r4)
	sth	r0,0x0(r30)	# write value

	li 	r3,0		# return 0
	lwz	r30,0x10(r1)	# restore context
	lwz	r31,0x14(r1)
	lwz	r0,0x1C(r1)
	mtspr	LR,r0
	addi	r1,r1,0x18
	blr

#*****************************************
# PWMRead (int axis, short int *value)
# Read to PWM channel 0 to 3 (4 axis board)
# Channel 0 : axis 1
# r3 = axis, r4= adresse Value
# Renvoie une valeur positive ou negative
#******************************************
PWMRead:
	stwu	r1,-0x18(r1)
	mfspr	r0,LR
	stw	r30,0x10(r1)
	stw	r31,0x14(r1)
	stw	r0,0x1C(r1)
	
	li	r31,0
	addis	r30,r31,A_MIOSHi	
	ori	r30,r30,0x600E
	
	lhz	r0,0x0(r30)		# Read A_MPWMSM
	sth	r0,0x0(r3)		# *r30 <- r0

	li 	r3,0			# return 0
	lwz	r30,0x10(r1)	# restore context
	lwz	r31,0x14(r1)
	lwz	r0,0x1C(r1)
	mtspr	LR,r0
	addi	r1,r1,0x18
	blr

#*****************************************
# WatchDog ()
# Write or Read using CS2 every clock cycle to turn on the watchdog
# CS2 configurated using BR2, OR2 in crt0.o to address 0FF00000
#******************************************
WatchDog:
	stwu	r1,-0x18(r1)
	mfspr	r0,LR
	stw	r30,0x10(r1)
	stw	r31,0x14(r1)
	stw	r0,0x1C(r1)
	
	li	r31,0
	addis	r30,r31,0x0FF0	
	ori	r30,r30,0x0000	#r30=0x0FF00000
	
	lwz	r0,0x0(r30)	#lecture a vide

	li 	r3,0		# return 0
	lwz	r30,0x10(r1)	# restore context
	lwz	r31,0x14(r1)
	lwz	r0,0x1C(r1)
	mtspr	LR,r0
	addi	r1,r1,0x18
	blr

#******************************************************	
#PWMDIsInt
#	Masque les interruptions liees au PWM
#******************************************************
PWMDisInt:
	# Save context r0,r11,r12,LR
	stwu	r1,-0x30(r1)    	# Make a 3 word frame in the stack
	stw	r0,0x10(r1)     	# Save r0
	stw	r11,0x14(r1)    	# Save r11
	stw	r12,0x18(r1)    	# Save r12	
	mfspr	r0,LR   	    	# Get LR Link Register 
	stw	r0,0x1C(r1)     	# Save it
	li	r0,0        		# Set r0=0x0
	
	addis	r11,r0,A_MIOSHi	    	# Disable Interrupt on PWM1
	ori	r11,r11,A_MIOS1ER0
	lhz	r12,0(r11)
	andi.	r12,r12,0xFFFD
	sth	r12,0(r11)
	
	# Restore Context r0,r11,r12,LR
	lwz	r0,0x1C(r1)     	# Get LR off stack
	mtspr	LR,r0       		# Restore LR Link Register 
	lwz	r12,0x18(r1)    	# Restore r12
	lwz	r11,0x14(r1)    	# Restore r11	
	lwz	r0,0x10(r1)     	# Restore r0
	addi	r1,r1,0x30      	# Restore Stack Pointer
	blr             			# Branch to Link Register, Return from Subroutine RTS 

#******************************************************	
#PWMENInt
#	Autorise les interruptions liees au PWM
#******************************************************
PWMEnInt:
	# Save context r0,r11,r12,LR
	stwu	r1,-0x30(r1)    	# Make a 3 word frame in the stack
	stw	r0,0x10(r1)     	# Save r0
	stw	r11,0x14(r1)    	# Save r11
	stw	r12,0x18(r1)    	# Save r12	
	mfspr	r0,LR   	    	# Get LR Link Register 
	stw	r0,0x1C(r1)     	# Save it
	li	r0,0        		# Set r0=0x0
	
	
	addis	r11,r0,A_MIOSHi  	# Enable interrupt on PWM1
	ori	r11,r11,A_MIOS1ER0
	lhz	r12,0(r11)
	ori	r12,r12,0x2
	sth	r12,0(r11)
	
	# Restore Context r0,r11,r12,LR
	lwz	r0,0x1C(r1)     	# Get LR off stack
	mtspr	LR,r0       		# Restore LR Link Register 
	lwz	r12,0x18(r1)    	# Restore r12
	lwz	r11,0x14(r1)    	# Restore r11	
	lwz	r0,0x10(r1)     	# Restore r0
	addi	r1,r1,0x30      	# Restore Stack Pointer
	blr             			# Branch to Link Register, Return from Subroutine RTS 
