#*****************************************************************************
#* File: TPUASM.S 
#* Version: 1.00,   15/10/1999
#* Author:  Meftah GHRISSI,  Robosoft (meftah@robosoft.fr) 
#-----------------------------------------------------------------------------
#* Modification:
#*   1.00 - Base version
#*   1.01 - ....
#-----------------------------------------------------------------------------

       .name           	"tpuasm.s"
       .text
       .include         "555regsdef.s"

	.xdef TPU3Inittcr1
	.xdef TCR1Read
	
# *************************************************
# Syntax
# A_NameHi : Refers MSB 16bit Address  for "name" Module 
# A_NameLo : Refers LSB 16bit Address  for "name" Register 
# V_Name   : Refers     16bit Value to set "name" Register 
     	A_TPU3AHi		=	0x0030
# *************************************************
# TPU Module Configuration Register
# TCR1P = 10 (divide by 4)
	A_TPUMCRLo		=	0x4400
	V_TPUMCR		=	0x4000
# *************************************************
# TPU Module Configuration Register 3
# EPSCKE = 1	Enhanced pre-scaler enable
# EPSCK	= 0xe (30)
	A_TPUMCR3Lo		=	0x442A
	V_TPUMCR3		=	0x004e
# *************************************************
# TPU Module Configuration Register 2
# DIV2 = 0
	A_TPUMCR2Lo		=	0x4428
	V_TPUMCR2		=	0x00A2
# *************************************************
# Disable Channels cleaning the two channel 
# priority bits on each of the FQD Channel Ch1:00 Ch0:00
# in CPR1 Channel Priority register
# (0 0 Disable)
# (0 1 Low)
# (1 0 Medium)
# (1 1 Hight)
	A_CPR1C76543210Lo	 =	0x441E		
	V_CPR1C76543210Dis	 =	0x0000
# Enable servicing by asigning a Priority 
# Both channel must have the same Priority Ch1:11 Ch0:11
	# V_CPR1C76543210Ena =	0xFFFF
	V_CPR1C76543210Ena	 =	-0x0001
# *************************************************
# Select FQD Funtion on both channels whit the FQD
# funtion n to their funtion select bits
# in CFSR2 Channel Function Select Reg2 for channels 7,6,5,4
# in CFSR3 Channel Function Select Reg3 for channels 3,2,1,0
# FQD = n6 = 0x6 = 0110
	A_CFSR2C7654Lo		=	0x4410
	V_CFSR2C7654		=	0x6666	
	A_CFSR3C3210Lo		=	0x4412
	V_CFSR3C3210		=	0x6666
# *************************************************
# Initialise CORR_PIN_STATE_ADDR & EDGE_TIME_LSB_ADDR  
# Channel (Example)
# (0  304100 EDGE_TIME)
# (0  304106 CHAN_PINSTATE)
# (0  304108 CORR_PIN_STATE_ADDR = 0x0016) 	#CPSA
# (0  30410A EDGE_TIME_LSB_ADDR  = 0x0001) 	#ETLA
# (1  304116 CHAN_PINSTATE)
# (1  304118 CORR_PIN_STATE_ADDR = 0x0006) 	#CPSA 
# (1  30411A EDGE_TIME_LSB_ADDR  = 0x0001)  	#ETLA
# in Parameter RAM on both chanels
# ********************************************************
	A_PRAM_C0_CPSALo	=	0x4508
	V_PRAM_C0_CPSA		=	0x0016
	A_PRAM_C0_ETLALo	=	0x450A
	V_PRAM_C0_ETLA		=	0x0001

	A_PRAM_C1_CPSALo	=	0x4518
	V_PRAM_C1_CPSA		=	0x0006
	A_PRAM_C1_ETLALo	=	0x451A
	V_PRAM_C1_ETLA		=	0x0001
# ********************************************************
	A_PRAM_C2_CPSALo	=	0x4528
	V_PRAM_C2_CPSA		=	0x0036
	A_PRAM_C2_ETLALo	=	0x452A
	V_PRAM_C2_ETLA		=	0x0021

	A_PRAM_C3_CPSALo	=	0x4538
	V_PRAM_C3_CPSA		=	0x0026
	A_PRAM_C3_ETLALo	=	0x453A
	V_PRAM_C3_ETLA		=	0x0021
# ********************************************************
	A_PRAM_C4_CPSALo	=	0x4548
	V_PRAM_C4_CPSA		=	0x0056
	A_PRAM_C4_ETLALo	=	0x454A
	V_PRAM_C4_ETLA		=	0x0041

	A_PRAM_C5_CPSALo	=	0x4558
	V_PRAM_C5_CPSA		=	0x0046
	A_PRAM_C5_ETLALo	=	0x455A
	V_PRAM_C5_ETLA		=	0x0041
# ********************************************************
	A_PRAM_C6_CPSALo	=	0x4568
	V_PRAM_C6_CPSA		=	0x0076
	A_PRAM_C6_ETLALo	=	0x456A
	V_PRAM_C6_ETLA		=	0x0061

	A_PRAM_C7_CPSALo	=	0x4578
	V_PRAM_C7_CPSA		=	0x0066
	A_PRAM_C7_ETLALo	=	0x457A
	V_PRAM_C7_ETLA		=	0x0061

# ********************************************************
# Initialse Position Count to the desired start value	
	A_PRAM_C0_PCountLo	=	0x4502
	V_PRAM_C0_PCount	=	0x0000

	A_PRAM_C2_PCountLo	=	0x4522
	V_PRAM_C2_PCount	=	0x0000

	A_PRAM_C4_PCountLo	=	0x4542
	V_PRAM_C4_PCount	=	0x0000

	A_PRAM_C6_PCountLo	=	0x4562
	V_PRAM_C6_PCount	=	0x0000
# ******************************************************
# Selec Primary and Secondary channel Ch1:01 Ch0:00
# in HSQR1 Host =ence reg
# (0 0 Primary Ch, Normal Mode)
# (0 1 Second  Ch, Normal Mode)
# (1 0 Primary Ch, Fast   Mode)
# (1 1 Second  Ch, Fast   Mode)
	A_HSQR1C76543210Lo 	=	0x4416
	V_HSQR1C76543210   	=	0x4444
# ******************************************************
# Initialize the function in each channel Ch1:11 Ch0:11
# HSRR1 Host Service =est reg
# (0 0 No Host Service)
# (0 1 Not Used)
# (1 0 Read TCR1)
# (1 1 Initialize)
	A_HSRR1C76543210Lo 	=	0x441A
	# V_HSRR1C76543210  =	0xFFFF	
	V_HSRR1C76543210   	=	-0x0001	
# ******************************************************
.macro SetReg AdRgLo,Value
		addis	r11,r0,A_TPU3AHi
		ori	r11,r11,\AdRgLo
		li	r12,\Value
		sth	r12,0(r11)
	.endm
.macro SetRegOr AdRgLo,Value
		addis	r11,r0,A_TPU3AHi
		ori	r11,r11,\AdRgLo
		lhz	r12,0(r11)
		ori	r12,r12,\Value
		sth	r12,0(r11)
	.endm

###############################
#TPU3Inittcr1
# Initilisation des canaux TPU
################################


TPU3Inittcr1:	
# Save context r0,r11,r12,LR,CR,SRR0,SRR1
	stwu	r1,-0x30(r1)	# Make a 3 word frame in the stack
	stw	r0,0x10(r1)	    # Save r0
	stw	r11,0x14(r1)	# Save r11
	stw	r12,0x18(r1)	# Save r12	
	mfspr	r0,LR		    # Get LR Link Register 
	stw	r0,0x1C(r1)	    # Save it
	li	r0,0		    #Set r0=0x0

	#configure with TPUMCRX
	SetRegOr A_TPUMCR3Lo	  , V_TPUMCR3	
	SetRegOr A_TPUMCRLo	      , V_TPUMCR	
	SetRegOr A_TPUMCR2Lo	  , V_TPUMCR2
	
	SetReg A_CPR1C76543210Lo  ,V_CPR1C76543210Dis       #Disable Clannels
	SetReg A_CFSR2C7654Lo	  ,V_CFSR2C7654		        #Select FQD funtion
	SetReg A_CFSR3C3210Lo	  ,V_CFSR3C3210

	SetReg A_PRAM_C0_CPSALo	  ,V_PRAM_C0_CPSA		    #Initialise CORR_PIN_STATE_ADDR
	SetReg A_PRAM_C0_ETLALo	  ,V_PRAM_C0_ETLA		    #Initialise EDGE_TIME_LSB_ADDR  
	SetReg A_PRAM_C1_CPSALo	  ,V_PRAM_C1_CPSA
	SetReg A_PRAM_C1_ETLALo	  ,V_PRAM_C1_ETLA

	SetReg A_PRAM_C2_CPSALo	  ,V_PRAM_C2_CPSA
	SetReg A_PRAM_C2_ETLALo	  ,V_PRAM_C2_ETLA
	SetReg A_PRAM_C3_CPSALo	  ,V_PRAM_C3_CPSA
	SetReg A_PRAM_C3_ETLALo   ,V_PRAM_C3_ETLA

	SetReg A_PRAM_C4_CPSALo   ,V_PRAM_C4_CPSA
	SetReg A_PRAM_C4_ETLALo   ,V_PRAM_C4_ETLA
	SetReg A_PRAM_C5_CPSALo	  ,V_PRAM_C5_CPSA
	SetReg A_PRAM_C5_ETLALo	  ,V_PRAM_C5_ETLA

	SetReg A_PRAM_C6_CPSALo	  ,V_PRAM_C6_CPSA
	SetReg A_PRAM_C6_ETLALo	  ,V_PRAM_C6_ETLA
	SetReg A_PRAM_C7_CPSALo	  ,V_PRAM_C7_CPSA
	SetReg A_PRAM_C7_ETLALo	  ,V_PRAM_C7_ETLA

	SetReg A_PRAM_C0_PCountLo ,V_PRAM_C0_PCount		 #Initialse Position Counts
	SetReg A_PRAM_C2_PCountLo ,V_PRAM_C2_PCount
	SetReg A_PRAM_C4_PCountLo ,V_PRAM_C4_PCount
	SetReg A_PRAM_C6_PCountLo ,V_PRAM_C6_PCount

	SetReg A_HSQR1C76543210Lo ,V_HSQR1C76543210	     #Selec Primary and Secondary channel
	SetReg A_HSRR1C76543210Lo ,V_HSRR1C76543210	     #Initialize the function in each channel 
	SetReg A_CPR1C76543210Lo  ,V_CPR1C76543210Ena    #Enable servicing by asigning a Priority 

# Restore Context r0,r11,r12,LR,CR,SRR0,SRR1
	lwz	r0,0x1C(r1)	      # Get LR off stack
	mtspr	LR,r0		      # Restore LR Link Register 
	lwz	r12,0x18(r1)      # Restore r12
	lwz	r11,0x14(r1)      # Restore r11	
	lwz	r0,0x10(r1)	      # Restore r0
	addi	r1,r1,0x30	      # Restore Stack Pointer
	blr			          # Branch to Link Register, Return from Subroutine RTS 


TCR1Read:
	stwu	r1,-0x18(r1)
	mfspr	r0,LR
	stw	r30,0x10(r1)
	stw	r31,0x14(r1)
	stw	r0,0x1C(r1)
	
	li	r31,0				# Ask to read TCR1
	addis	r30,r31,A_TPU3AHi	
	ori	r30,r30,0x441a		
	li	r31,0x0002		    # Put 10 in ch 0
	sth	r31,0(r30)

	li	r31,0				# Read TCR1
	addis	r30,r31,A_TPU3AHi	
	ori	r30,r30,0x4504
	lhz	r0,0x0(r30)
	andi.	r30,r0,0xffff
	stw	r30,0x0(r3)		    # Return value

	li 	r3,0		        # Return 0
	lwz	r30,0x10(r1)	    # Restore context
	lwz	r31,0x14(r1)
	lwz	r0,0x1C(r1)
	mtspr	LR,r0
	addi	r1,r1,0x18
	blr

	
